org.osgi.framework.hooks.service

## Interface FindHook

    @ConsumerType
    public interface FindHook

OSGi Framework Service Find Hook Service.

Bundles registering this service will be called during framework service find (get service references) operations.

Author:
  $Id: 4325a49f8c29ac9e7f32e8450db26148bbda5642 $

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `find(BundleContext context, String name, String filter, boolean allServices, Collection<ServiceReference<?>> references)` Find hook method.

### Method Detail

#### find

    void find(BundleContext context,
              String name,
              String filter,
              boolean allServices,
              Collection<ServiceReference<?>> references)

Find hook method. This method is called during the service find operation (for example, `BundleContext.getServiceReferences(String, String)` ). This method can filter the result of the find operation.

Parameters:
  `context` - The bundle context of the bundle performing the find operation.
  `name` - The class name of the services to find or `null` to find all services.
  `filter` - The filter criteria of the services to find or `null` for no filter criteria.
  `allServices` - `true` if the find operation is the result of a call to `BundleContext.getAllServiceReferences(String, String)`
  `references` - A collection of Service References to be returned as a result of the find operation. The implementation of this method may remove service references from the collection to prevent the references from being returned to the bundle performing the find operation. The collection supports all the optional `Collection` operations except `add` and `addAll`. Attempting to add to the collection will result in an `UnsupportedOperationException`. The collection is not synchronized.